unit hdunit;

{
  color mixer dialog form with history
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, dav7ColorMixer, Buttons;

type
  Tcolordialogform = class(TForm)
    colormixer: Tdav7Colormixer;
    historybox: TPaintBox;
    Label1: TLabel;
    BiOKbtn: TBitBtn;
    cancelBtn: TBitBtn;
    showbox: TPaintBox;
    procedure FormPaint(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure historyboxPaint(Sender: TObject);
    procedure colormixerSelect(sender: TObject; color: Integer);
    procedure showboxPaint(Sender: TObject);
    procedure historyboxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  colordialogform : Tcolordialogform;

function colordialog(var col : dword) : boolean;

implementation

{$R *.dfm}

uses unit1;

const maxhistory = 10;

var colorhistory : array[1..maxhistory+1] of dword;
    hcount : byte;

//-- history --

procedure add2history(c : dword);
//add color c to history
var i,j : byte;
    hit : boolean;
begin
 i := 1;
 hit := false;
 while (i <= hcount) and (hit = false) do
  if colorhistory[i] = c then hit := true
   else inc(i);
 for j := i downto 2 do colorhistory[j] := colorhistory[j-1];//shift up
 if (i > hcount) and (i <= maxhistory) then hcount := i; 
 colorhistory[1] := c;
end;

//-- main call --

function colordialog(var col : dword) : boolean;
begin
 with colordialogform do
  begin
   colormixer.color := col;
   showmodal;
   if colordialogform.ModalResult = mrOK then
    begin
     col := colormixer.color;
     result := true;
     add2history(col);
    end
    else result := false; 
  end; 
end;

procedure Tcolordialogform.FormPaint(Sender: TObject);
begin
 paintedges(historybox);
 paintedges(showbox);
end;

procedure Tcolordialogform.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if key = #27 then   //ESCAPE
  modalresult := mrCancel;
end;

procedure Tcolordialogform.historyboxPaint(Sender: TObject);
var i : byte;
    y : word;
begin
 with historybox do with canvas do
  begin
   brush.Style :=bsSolid;
   pen.color := $000000;
   pen.Width := 1;
   for i := 1 to hcount do
    begin
     y := (i-1)*20;
     brush.Color := colorhistory[i];
     fillrect(rect(0,y,60,y+20));
     if i < 10 then
      begin
       moveto(0,y+19);
       lineto(60,y+19);
      end;
    end;
  end;
end;

procedure Tcolordialogform.colormixerSelect(sender: TObject;
  color: Integer);
begin
 showbox.Invalidate;
end;

procedure Tcolordialogform.showboxPaint(Sender: TObject);
begin
 with showbox do with canvas do
  begin
   brush.Style := bsSolid;
   brush.Color := colormixer.color;
   fillrect(rect(0,0,width,height));
  end;
end;

procedure Tcolordialogform.historyboxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
//color selection from history
var m,n : byte;
    c : dword;
begin
 n := y div 20;
 m := y mod 20;
 if (n+1 <= hcount) and (m > 3) and (m < 17) then
  begin
   c := colorhistory[n+1];
   colorMixer.color := c;
   add2history(c);
   modalresult := mrOK;
  end;
end;

end.
